# Contributing Guide

## Getting Started

- Make sure you have a [GitHub Account](https://github.com/signup/free).
- Make sure the [Dart SDK](https://www.dartlang.org/tools/sdk/) is installed on your system.
- Make sure you have [Git](http://git-scm.com/) installed on your system.
- [Fork](https://help.github.com/articles/fork-a-repo) the [repository](https://github.com/DirectMyFile/irc.dart) on GitHub.

## Making Changes

- [Create a branch](https://help.github.com/articles/creating-and-deleting-branches-within-your-repository) for your changes.
- [Commit your code](http://git-scm.com/book/en/Git-Basics-Recording-Changes-to-the-Repository) for each logical change (see [tips for creating better commit messages](http://robots.thoughtbot.com/5-useful-tips-for-a-better-commit-message)).
- [Push your change](https://help.github.com/articles/pushing-to-a-remote) to your fork.
- [Create a Pull Request](https://help.github.com/articles/creating-a-pull-request) on GitHub for your change.

## Code Style

json2csv follows the [Dart Style Guide](https://www.dartlang.org/articles/style-guide/). Please note that if your code is not 
formatted according to the guide as much as possible, we will reject your Pull Request until it is fixed. Some things such as long 
lines will generally be accepted, however try to make it smaller if possible.

## Contacting Us

- IRC: `#directcode on irc.esper.net`
- Email: `k.endfinger@dglogik.com`
